using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.DirectoryServices;


namespace RB
{
    public partial class LPFC : Form
    {
        String groupName = String.Empty;

        public LPFC()
        {
            InitializeComponent();
        }

        private void btnLoadPeers_Click(object sender, EventArgs e)
        {
            if (groupName == String.Empty)
            {
                MessageBox.Show("You must Enter a WorkGroup to proceed", "Alert");
                return;
            }
            Database db = new Database();
            // db.ExecuteNonQueryFn("truncate table peerlist");
            LoadUsers();
        }

        private void LoadUsers()
        {

            listViewIP.Items.Clear();
            try
            {
                DirectoryEntry DomainEntry = new DirectoryEntry("WinNT://" + groupName + "");
                DomainEntry.Children.SchemaFilter.Add("Computer");
                foreach (DirectoryEntry machine in DomainEntry.Children)
                {
                    string strMachineName = machine.Name;
                    IPAddress IPAddress;
                    try
                    {
                        IPAddress = getIPByName(machine.Name);
                    }
                    catch
                    {
                        continue;
                    }
                    progressBar1.Value = progressBar1.Value + 1;
                    listViewIP.Items.Add(IPAddress.ToString());
                    //IPList.Add(IPAddress.ToString());
                }
                progressBar1.Value = progressBar1.Maximum;
                //txtSourceNode.Text = FindIP();



            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private IPAddress getIPByName(string strMachineName)
        {
            try
            {
                IPHostEntry hostInfo = Dns.GetHostEntry(strMachineName);
                return hostInfo.AddressList[0];
            }
            catch (Exception ex)
            {
                MessageBox.Show("Unable to connect with the system: " + strMachineName);
                //listBox2.Items.Add(strMachineName.ToString());
                throw ex;
                //return "";
            }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (txtWorkGroup.Text.Trim() == String.Empty)
            {
                MessageBox.Show("You must Enter a WorkGroup to proceed", "Alert");
                return;
            }

            DialogResult dr = MessageBox.Show("U have chosen " + txtWorkGroup.Text.Trim() + " as Your WorkGroup. Do you want to proceed", "Confirmation", MessageBoxButtons.OKCancel);
            if (dr == DialogResult.OK)
            {
                groupName = txtWorkGroup.Text.Trim();                
            }
            else
                return;
        }

        private void btnEmptyTable_Click(object sender, EventArgs e)
        {
            Database db = new Database();
            db.ExecuteNonQueryFn("truncate table clusters");
        }

        private void btnInsert_Click(object sender, EventArgs e)
        {
            Database db = new Database();
            if(textBox1.Text.Trim() != String.Empty)
                db.ExecuteNonQueryFn("insert into clusters values('" + textBox1.Text + "')");
            if (textBox2.Text.Trim() != String.Empty)
                db.ExecuteNonQueryFn("insert into clusters values('" + textBox2.Text + "')");
            if (textBox3.Text.Trim() != String.Empty)
                db.ExecuteNonQueryFn("insert into clusters values('" + textBox3.Text + "')");
            if (textBox4.Text.Trim() != String.Empty)
                db.ExecuteNonQueryFn("insert into clusters values('" + textBox4.Text + "')");
        }

        private void LPFC_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            FrmSearch fs = new FrmSearch();
            fs.Show();
            this.Hide();
        }       
    }
}