using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace RB
{
    public partial class FrmSearch : Form
    {
        List<string> cList1;
        Database db = new Database();

        int[] nodes = new int[] { 5555, 6000 };

        public FrmSearch()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string cList;
            bool flag = IsResourceAlreadySearched(out cList);

            if (!flag)
            {
                FillClusterListFromClustersTable();
                if (cList1.Count == 0)
                {
                    MessageBox.Show("No cluster present in the clusters table");
                    return;
                }
                InsertResourceInSearchTable();

                //cList1 = new List<string>();
                //cList1.Add("192.168.0.34");
                //cList1.Add("192.168.0.40");
                //cList1.Add("192.168.0.33");
                

                foreach (string c in cList1)
                {
                    bool addToClusterList = false;
                    foreach (int n in nodes)
                    {
                        richTextBox1.Text = String.Empty;
                        TcpClient tcpClient;
                        NetworkStream networkStream;                        

                        try
                        {
                            tcpClient = new TcpClient(c,n);
                            networkStream = tcpClient.GetStream();
                            BinaryWriter bw = new BinaryWriter(networkStream);
                            BinaryReader br = new BinaryReader(networkStream);
                            byte[] bytes = System.Text.Encoding.ASCII.GetBytes("Lord.txt");
                            bw.Write(bytes.Length);
                            bw.Write(bytes);
                            bool r = br.ReadBoolean();

                            if (r)
                            {
                                addToClusterList = r;
                                int length = br.ReadInt32();
                                bytes = br.ReadBytes(length);
                                string str = System.Text.Encoding.ASCII.GetString(bytes);
                                richTextBox1.Text = str;
                                MessageBox.Show("Content from "+c);
                            }
                            tcpClient.Close();
                        }
                        catch (SocketException ex)
                        {
                            MessageBox.Show(ex.ToString());
                        }
                    }
                    if (addToClusterList)
                    {
                        db.ExecuteNonQueryFn("update searchtable set cluster=cluster+'"+c+";' where resource='"+textBox1.Text+"'");
                    }
                }
            }
            else
            {
                string[] arr = cList.Split(new char[] { ';' });
                cList1 = new List<string>();                
                foreach (string s in arr)
                    if (s.Trim() != string.Empty)
                        cList1.Add(s);

                foreach (string c in cList1)
                {
                    //bool addToClusterList = false;
                    foreach (int n in nodes)
                    {
                        richTextBox1.Text = String.Empty;
                        TcpClient tcpClient;
                        NetworkStream networkStream;

                        try
                        {
                            tcpClient = new TcpClient(c, n);
                            networkStream = tcpClient.GetStream();
                            BinaryWriter bw = new BinaryWriter(networkStream);
                            BinaryReader br = new BinaryReader(networkStream);
                            byte[] bytes = System.Text.Encoding.ASCII.GetBytes("Lord.txt");
                            bw.Write(bytes.Length);
                            bw.Write(bytes);
                            bool r = br.ReadBoolean();

                            if (r)
                            {
                                //addToClusterList = r;
                                int length = br.ReadInt32();
                                bytes = br.ReadBytes(length);
                                string str = System.Text.Encoding.ASCII.GetString(bytes);
                                richTextBox1.Text = str;
                                MessageBox.Show("Content from " + c);
                            }
                            tcpClient.Close();
                        }
                        catch (SocketException ex)
                        {
                            MessageBox.Show(ex.ToString());
                        }
                    }
                    //if (addToClusterList)
                    //{
                    //    db.ExecuteNonQueryFn("update searchtable set cluster=cluster+'" + c + ";' where resource='" + textBox1.Text + "'");
                    //}
                }
            }             
        }

        private void InsertResourceInSearchTable()
        { 
            db.ExecuteNonQueryFn("insert into searchtable values ('"+textBox1.Text+"','')");
        }

        private bool IsResourceAlreadySearched(out string cList)
        {
            bool result;
            IDataReader dr = db.ExecuteReaderFn("select * from searchtable where resource='"+textBox1.Text+"'");

            if (dr.Read())
            {
                cList = dr.GetString(1);
                result = true;
            }
            else
            {
                cList = null;
                result = false;
            }

            dr.Close();
            return result;
        }

        private void FillClusterListFromClustersTable()
        {
            cList1 = new List<string>();
            
            IDataReader dr =  db.ExecuteReaderFn("select * from clusters");
            while (dr.Read())
            {
                cList1.Add(dr.GetString(0));
            }
            dr.Close();            
        }

        private void FillClusterListFromSearchTable()
        {
            cList1 = new List<string>();

            IDataReader dr = db.ExecuteReaderFn("select * from clusters");
            while (dr.Read())
            {
                cList1.Add(dr.GetString(0));
            }
            dr.Close();
        }

        private void FrmSearch_Load(object sender, EventArgs e)
        {
                   
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FillClusterListFromClustersTable();
            db.ExecuteNonQueryFn("update searchtable set cluster='' where resource='" + textBox1.Text + "'");
            foreach (string c in cList1)
            {
                bool addToClusterList = false;
                foreach (int n in nodes)
                {
                    richTextBox1.Text = String.Empty;
                    TcpClient tcpClient;
                    NetworkStream networkStream;

                    try
                    {
                        tcpClient = new TcpClient(c, n);
                        networkStream = tcpClient.GetStream();
                        BinaryWriter bw = new BinaryWriter(networkStream);
                        BinaryReader br = new BinaryReader(networkStream);
                        byte[] bytes = System.Text.Encoding.ASCII.GetBytes("Lord.txt");
                        bw.Write(bytes.Length);
                        bw.Write(bytes);
                        bool r = br.ReadBoolean();

                        if (r)
                        {
                            addToClusterList = r;
                            int length = br.ReadInt32();
                            bytes = br.ReadBytes(length);
                            //string str = System.Text.Encoding.ASCII.GetString(bytes);
                            //richTextBox1.Text = str;
                            //MessageBox.Show("Content from " + c);
                        }
                        tcpClient.Close();
                    }
                    catch (SocketException ex)
                    {
                        MessageBox.Show(ex.ToString());
                    }
                }
                if (addToClusterList)
                {
                    db.ExecuteNonQueryFn("update searchtable set cluster=cluster+'" + c + ";' where resource='" + textBox1.Text + "'");
                    MessageBox.Show(c);
                }
            }
        }
    }
}