using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Collections;
using System.Configuration;

namespace RBNode1
{
    public partial class Form1 : Form
    {
        string rPath;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            rPath = ConfigurationManager.AppSettings["rPath"].Trim();
            ServerStart();        
        }

        private void ServerStart()
        {
            MessageBox.Show("Node1 Started");

            TcpListener tcpListener;
            NetworkStream networkStream;

            while (true)
            {
                try
                {
                    tcpListener = new TcpListener(IPAddress.Any, 5555);
                    tcpListener.Start();
                    TcpClient tcpClient = tcpListener.AcceptTcpClient();
                    networkStream = tcpClient.GetStream();

                    BinaryWriter bw = new BinaryWriter(networkStream);
                    BinaryReader br = new BinaryReader(networkStream);

                    int length = br.ReadInt32();

                    byte[] bytes = br.ReadBytes(length);
                    string resource = System.Text.Encoding.ASCII.GetString(bytes);
                    bool result = File.Exists(rPath + "\\" + resource);

                    bw.Write(result);

                    if (result)
                    {
                        StreamReader sr = new StreamReader(rPath + "\\" + resource);
                        string str = sr.ReadToEnd();
                        sr.Close();

                        bytes = System.Text.Encoding.ASCII.GetBytes(str);
                        bw.Write(bytes.Length);
                        bw.Write(bytes);
                    }
                    tcpClient.Close();
                    tcpListener.Stop();
                }
                catch (SocketException ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
        }        
    }
}